var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import CkanSharedTraits from "./CkanSharedTraits";
import CatalogMemberReferenceTraits from "./CatalogMemberReferenceTraits";
import mixTraits from "../mixTraits";
import MappableTraits from "./MappableTraits";
import primitiveTrait from "../Decorators/primitiveTrait";
import UrlTraits from "./UrlTraits";
import { traitClass } from "../Trait";
let CkanCatalogItemTraits = class CkanCatalogItemTraits extends mixTraits(UrlTraits, MappableTraits, CkanSharedTraits, CatalogMemberReferenceTraits) {
    constructor() {
        super(...arguments);
        Object.defineProperty(this, "datasetId", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "resourceId", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
    }
};
__decorate([
    primitiveTrait({
        name: "Dataset ID",
        description: "The CKAN ID of the dataset.",
        type: "string"
    })
], CkanCatalogItemTraits.prototype, "datasetId", void 0);
__decorate([
    primitiveTrait({
        name: "Magda Record Data",
        description: "The Resource ID of the dataset to use",
        type: "string"
    })
], CkanCatalogItemTraits.prototype, "resourceId", void 0);
CkanCatalogItemTraits = __decorate([
    traitClass({
        description: `Creates a calalog item that references a ckan item.

  <strong>Note:</strong> 
  <li>The property <code>resourceId</code> in the example below is a Ckan resource Id that references a geospatial type (wms) data.</li>`,
        example: {
            url: "https://discover.data.vic.gov.au",
            type: "ckan-item",
            resourceId: "22b8cf52-4583-4609-a3da-a6e1805829d9",
            name: "A Ckan Item (WMS)",
            id: "some id"
        }
    })
], CkanCatalogItemTraits);
export default CkanCatalogItemTraits;
//# sourceMappingURL=CkanItemReferenceTraits.js.map