var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import anyTrait from "../Decorators/anyTrait";
import primitiveTrait from "../Decorators/primitiveTrait";
import { traitClass } from "../Trait";
import mixTraits from "../mixTraits";
import AutoRefreshingTraits from "./AutoRefreshingTraits";
import CatalogMemberTraits from "./CatalogMemberTraits";
import LegendOwnerTraits from "./LegendOwnerTraits";
import MappableTraits from "./MappableTraits";
import TimeVaryingTraits from "./TimeVaryingTraits";
import UrlTraits from "./UrlTraits";
let CzmlCatalogItemTraits = class CzmlCatalogItemTraits extends mixTraits(AutoRefreshingTraits, TimeVaryingTraits, UrlTraits, CatalogMemberTraits, LegendOwnerTraits, MappableTraits) {
    constructor() {
        super(...arguments);
        Object.defineProperty(this, "czmlData", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "czmlString", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
    }
};
__decorate([
    anyTrait({
        name: "CZML Data",
        description: "A CZML data array."
    })
], CzmlCatalogItemTraits.prototype, "czmlData", void 0);
__decorate([
    primitiveTrait({
        type: "string",
        name: "CZML String",
        description: "A CZML string."
    })
], CzmlCatalogItemTraits.prototype, "czmlString", void 0);
CzmlCatalogItemTraits = __decorate([
    traitClass({
        description: `Creates one catalog item from url that points to a czml file.
  
  <strong>Note:</strong> If the model is not visible, try to disable the terrain by unchecking the box "Terrain hides underground features".`,
        example: {
            type: "czml",
            url: "https://tiles.terria.io/terriajs-examples/czml/smooth.czml",
            name: "czml example",
            id: "some unique ID"
        }
    })
], CzmlCatalogItemTraits);
export default CzmlCatalogItemTraits;
//# sourceMappingURL=CzmlCatalogItemTraits.js.map