var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import objectArrayTrait from "../Decorators/objectArrayTrait";
import primitiveTrait from "../Decorators/primitiveTrait";
import { traitClass } from "../Trait";
import mixTraits from "../mixTraits";
import EnumDimensionTraits from "./DimensionTraits";
import LegendOwnerTraits from "./FeatureInfoTraits";
import SdmxCommonTraits from "./SdmxCommonTraits";
import TableTraits from "./Table/TableTraits";
import UrlTraits from "./UrlTraits";
export class SdmxDimensionTraits extends mixTraits(EnumDimensionTraits) {
    constructor() {
        super(...arguments);
        Object.defineProperty(this, "position", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
    }
}
__decorate([
    primitiveTrait({
        type: "string",
        name: "Position",
        description: "The position attribute specifies the position of the dimension in the data structure definition, starting at 0. This is important for making sdmx-csv requests"
    })
], SdmxDimensionTraits.prototype, "position", void 0);
let SdmxCatalogItemTraits = class SdmxCatalogItemTraits extends mixTraits(SdmxCommonTraits, UrlTraits, TableTraits, LegendOwnerTraits) {
    constructor() {
        super(...arguments);
        Object.defineProperty(this, "dataflowId", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "agencyId", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "unitMeasure", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "dimensions", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
    }
};
__decorate([
    primitiveTrait({
        type: "string",
        name: "Dataflow ID",
        description: "SDMX Dataflow ID"
    })
], SdmxCatalogItemTraits.prototype, "dataflowId", void 0);
__decorate([
    primitiveTrait({
        type: "string",
        name: "Agency ID",
        description: "SDMX Agency ID"
    })
], SdmxCatalogItemTraits.prototype, "agencyId", void 0);
__decorate([
    primitiveTrait({
        type: "string",
        name: "Unit Measure",
        description: "This string is essentially 'units' for the dataset. If a UNIT_MEASURE SDMX attribute exists in this dataflow, the default `unitMeasure` will be determined from it."
    })
], SdmxCatalogItemTraits.prototype, "unitMeasure", void 0);
__decorate([
    objectArrayTrait({
        type: SdmxDimensionTraits,
        name: "Dimensions",
        description: "Dimensions",
        idProperty: "id"
    })
], SdmxCatalogItemTraits.prototype, "dimensions", void 0);
SdmxCatalogItemTraits = __decorate([
    traitClass({
        description: `Creates one catalog item from url that points to an sdmx service.`,
        example: {
            type: "sdmx-json",
            url: "https://api.data.abs.gov.au",
            dataflowId: "ABS_REGIONAL_LGA2017",
            name: "sdmx-json example",
            agencyId: "ABS",
            id: "some unique id"
        }
    })
], SdmxCatalogItemTraits);
export default SdmxCatalogItemTraits;
//# sourceMappingURL=SdmxCatalogItemTraits.js.map