# Customizing your Data's Appearance

**Warning: This section needs to be updated for TerriaJS version 8.**

You can customize your data's appearance by using a small `json` configuration file to
describe the settings you want to use. Without such guidance, TerriaJS chooses
default settings, eg. the size of the points, the color scale, how to cluster values in the
legend, and how to display feature information in the "feature info panel".

In fact the json is exactly the same as the initialization file,
and can be included there too.

This section explains how you can use such a file to improve the look of your data:

-   [Customizing the Appearance of Tabular Data](./tabular-data.md)
-   [Customizing the Appearance of Imagery Data](./imagery-data.md)
-   [Customizing the Feature Info Template](./feature-info-template.md)
