TerriaJS can be extensively customized, often without writing any code. The catalog and many aspects of the look and feel are controlled by JSON configuration files.

This section explains the various ways to customize a TerriaJS application. It assumes you have already completed the [Getting Started](../getting-started.md) section and have a working Terria Map.

-   [Client-side Config](client-side-config.md): Configure which catalog (init) files to load, the application name and support email address, the branding at the top of the application, disclaimers, keys for Bing Maps and Google Analytics, and more.
-   [Initialization Files](initialization-files.md): TerriaJS init files describe the catalog that will be presented to the user, the initial map view, and more. Init files let you connect TerriaJS to your servers and data.
-   [Server-side Config](server-side-config.md): Configure which domains the server will proxy for (to avoid [Cross-Origin Resource Sharing (CORS) problems](../connecting-to-data/cross-origin-resource-sharing.md)), persistence of sharing data, and more.
-   [Skinning](skinning.md): Customize the look and feel of a TerriaJS application.
-   [Cloning and Building](cloning-and-building.md): Build TerriaMap locally to customize your application further
